var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var imgbg2png = new Image();
var imgb10png = new Image();
var imga2spng = new Image();
var imga2hpng = new Image();
var imga2mpng = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    imgbg2png.src = "bg2.png";
    context.drawImage(imgbg2png, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "45px BarMKodeInverse";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FF0000";
    text = "OR";
    context.fillText(text, 180, 95);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "76px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFC896";
    text = ((hours<10) ? "0"+hours : hours.toString()) + ":" + ((minutes<10) ? "0"+minutes : minutes.toString());
    context.fillText(text, 161, 163);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "40px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFC896";
    text = ((seconds<10) ? "0"+seconds : seconds.toString());
    context.fillText(text, 280, 174);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "28px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = (date.getHours()<12 ? 'am' : 'pm');
    context.fillText(text, 278, 146);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "40px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = (((date.getMonth() + 1) < 10) ? "0" + (date.getMonth() + 1) : (date.getMonth() + 1).toString()) + "." + ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    context.fillText(text, 154, 221);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "28px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = "Text";
    context.fillText(text, 188, 266);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "28px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = dayOfWeek[date.getDay()];
    context.fillText(text, 239, 224);
    context.restore();
    context.save();

    imgb10png.src = "b10.png";
    context.globalAlpha = 0.7
    context.drawImage(imgb10png, 142, 255, 23, 23);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((seconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imga2spng.src = "a2s.png";
    context.drawImage(imga2spng, -5, -180, 10, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imga2hpng.src = "a2h.png";
    context.drawImage(imga2hpng, -5, -180, 10, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imga2mpng.src = "a2m.png";
    context.drawImage(imga2mpng, -5, -180, 10, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

};
